/* Command-line interface for lexically C-like languages -*- c -*- */

#ifndef CMDLINE_H_
# define CMDLINE_H_

/** @file cmdline.h
 * Command-line interface for lexically C-like languages
 */

# ifdef __cplusplus
extern "C" {
# endif /* __cplusplus */

# ifdef HAS_READLINE
  /** Initialize the command line interface
   * @param name		name of the program
   * @param attempted_completer	the custom completion function
   * @param entry_completer	entry completion function
   */
  void init_cmdline (const char* progname,
		     char** (*attempted_completer) (const char*, int, int),
		     char* (*entry_completer) (const char*, int));
# endif /* HAS_READLINE */

  /** Read a string, possibly split over multiple lines
   * @param prompt	Prompt to be displayed to the user
   * @param prompt2	Prompt for continuation lines
   * @return		pointer to the string; NULL on EOF
   */
  const char* cmdline (const char* prompt, const char* prompt2);

# ifdef __cplusplus
}
# endif /* __cplusplus */

#endif /* CMDLINE_H_ */
